Calendar Settings in JavaScript Gantt Chart Control

The Gantt Chart control supports advanced calendar configuration through the calendarSettings property, enabling management of working hours, holidays, and task-specific scheduling. Calendar settings control how the Gantt Chart calculates task duration, determines working days, and schedules dependencies.

The calendarSettings property contains two key configurations:

  • Project Calendar: Defines working hours and holidays for the entire project, applied to all tasks by default
  • Task Calendars: Defines custom working days and holidays for specific tasks, enabling team-specific or shift-based scheduling

Project calendar

The calendarSettings.projectCalendar defines the default working hours and non-working days for the entire project. All tasks follow the project calendar unless assigned a task-specific calendar.

Configure project working hours and exceptions

Working hours are defined per day using start and end times. The following example configures the project to have working hours from 9:00 AM to 5:00 PM with a lunch break from 12:00 PM to 1:00 PM. Calendar exceptions allow overriding working hours for specific dates, enabling custom scheduling for special working days or non-working days that don’t fit the standard holiday definition:

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    projectStartDate: new Date('04/01/2026'),
    projectEndDate: new Date('04/30/2026'),
    taskFields: {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    },
    labelSettings: {
        leftLabel: 'TaskName'
    },
    calendarSettings: {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 12 },
                { from: 13, to: 17 }
            ],
            exceptions: [
                { from: new Date('04/06/2026'), to: new Date('04/06/2026'), label: 'Extended Working Day' }
            ]
        }
    }
});

ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css">
    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="Gantt"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Define project holidays

Holidays are non-working dates that exclude time from task calculations. The following example defines holidays for April 10 and April 17, excluding these dates from task scheduling calculations:

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    projectStartDate: new Date('04/01/2026'),
    projectEndDate: new Date('04/30/2026'),
    taskFields: {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    },
    labelSettings: {
        leftLabel: 'TaskName'
    },
    calendarSettings: {
        projectCalendar: {
            holidays: [
                { from: new Date('04/10/2026'), to: new Date('04/10/2026'), label: 'Holiday 1' },
                { from: new Date('04/17/2026'), to: new Date('04/17/2026'), label: 'Holiday 2' }
            ]
        }
    }
});

ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css">
    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="Gantt"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Task calendars

Task calendars enable specific tasks to use custom working days and holidays instead of the project calendar. This is useful for managing work across different shifts, regions, or external teams with different availability.

Assign task-specific calendars with exceptions

To assign a custom calendar to a task, first define the calendar in calendarSettings.taskCalendar, then reference it using the calendarId property in the task data. Calendar exceptions allow defining specific dates with custom working days, enabling team-specific scheduling adjustments such as split shifts or holidays that differ from the main schedule.

When a task is assigned a calendar through calendarId, that task follows only the assigned task calendar. The assigned task calendar overrides the project calendar for that task. Working days, holidays, and calendar exceptions defined in the assigned calendar are used when calculating the task schedule and working duration. Other task calendars are not considered when scheduling that task.

The following example defines two task calendars with different working days, task-specific exceptions, and assigns them to specific tasks:

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    projectStartDate: new Date('04/01/2026'),
    projectEndDate: new Date('04/30/2026'),
    taskFields: {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        calendarId: 'CalendarId'
    },
    labelSettings: {
        leftLabel: 'TaskName'
    },
    calendarSettings: {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 17 }
            ]
        },
        taskCalendars: [
            {
                calendarId: 'day-shift',
                workingTime: [
                    { from: 9, to: 17 }
                ],
                holidays: [],
                exceptions: [
                    { from: new Date('04/09/2026'), to: new Date('04/09/2026'), name: 'Team Meeting Day', isWorking: true, workingTime: [{ from: 10, to: 16 }] }
                ]
            },
            {
                calendarId: 'night-shift',
                workingTime: [
                    { from: 17, to: 9 }
                ],
                holidays: [],
                exceptions: [
                    { from: new Date('04/10/2026'), to: new Date('04/10/2026'), name: 'Maintenance Window', isWorking: true, workingTime: [{ from: 18, to: 8 }] }
                ]
            }
        ]
    }
});

ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css">
    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="Gantt"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Define task calendar holidays

Task calendars can include holidays that override project calendar holidays for the assigned task. These holidays are considered when calculating the task schedule and working duration. The following example configures a task calendar with specific holidays:

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    projectStartDate: new Date('04/01/2026'),
    projectEndDate: new Date('04/30/2026'),
    taskFields: {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        calendarId: 'CalendarId'
    },
    labelSettings: {
        leftLabel: 'TaskName'
    },
    calendarSettings: {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 17 }
            ],
            holidays: [
                { from: new Date('04/10/2026'), to: new Date('04/10/2026'), label: 'Regional Holiday' }
            ]
        },
        taskCalendars: [
            {
                calendarId: 'local-team',
                holidays: [
                    { from: new Date('04/05/2026'), to: new Date('04/05/2026'), label: 'Local Holiday' }
                ]
            },
            {
                calendarId: 'offshore-team',
                holidays: [
                    { from: new Date('04/08/2026'), to: new Date('04/08/2026'), label: 'Offshore Holiday' }
                ]
            }
        ]
    }
});

ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css">
    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="Gantt"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Configure hours per day for task durations

The hoursPerDay property defines the number of hours used to represent one day when calculating task durations. Changing hoursPerDay recalculates day-based duration values using the existing working duration of the task. This affects how duration is displayed and calculated in days, but does not modify the task’s start date, end date, or underlying working duration.

For example, a task with 32 hours of working duration is displayed as 4 days when hoursPerDay is set to 8. If hoursPerDay is changed to 16, the same task is displayed as 2 days. The task schedule remains unchanged because the underlying working duration is not modified.

The following example demonstrates how changing hoursPerDay affects duration calculations.

var ganttChart = new ej.gantt.Gantt({
	dataSource: GanttData,
	height: '450px',
	hoursPerDay: 8,
	projectStartDate: new Date('04/01/2026'),
	projectEndDate: new Date('04/30/2026'),
	taskFields: {
		id: 'TaskId',
		name: 'TaskName',
		startDate: 'StartDate',
		duration: 'Duration',
		parentID: 'ParentId'
	},
	labelSettings: {
		leftLabel: 'TaskName'
	},
	calendarSettings: {
		projectCalendar: {
			workingTime: [
				{ from: 9, to: 12 },
				{ from: 13, to: 17 }
			],
			exceptions: [
				{ from: new Date('04/06/2026'), to: new Date('04/06/2026'), label: 'Extended Working Day'}
			]
		}
	}
});
ganttChart.appendTo('#Gantt');

var addBtn = new ej.buttons.Button();
addBtn.appendTo('#updateHoursPerDay');

document.getElementById('updateHoursPerDay').addEventListener('click', function () {
	ganttChart.hoursPerDay = 16;
});
<!DOCTYPE html>
<html lang="en">

<head>
     <title>EJ2 Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Typescript Gantt Controls" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
	<link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
     <div id='loader'>Loading....</div>
    <div id='container'>
	   <button id="updateHoursPerDay">Update HoursPerDay</button>  
        <div id='Gantt'></div>        
    </div>
</body>

</html>

Note: The default hoursPerDay value is 8 hours. When a task has 4 days duration with the hoursPerDay value of 6, the total working hours = 4 days × 6 hours = 24 hours. If the calendar’s working time is configured as 24 hours (0:00 to 24:00), these 24 hours fit within a single calendar day, so the task displays as 1 calendar day on the chart, even though the duration specification is 4 days.

Impact on task scheduling

Calendar settings directly affect how task duration is calculated and when tasks are scheduled:

  • Working hours: Task durations ignore non-working hours. A 2-day task completed during 9 AM-5 PM working hours uses the same elapsed time as a 2-day task across multiple days with shorter working hours
  • Holidays: Tasks skip over holiday dates, extending the end date accordingly to maintain the required working duration
  • Weekends: By default, weekends are treated as non-working days when includeWeekend is set to false
  • Task dependencies: Dependency calculations use the predecessor task’s calendar to determine when the successor task can start
  • Task calendars: Tasks without an assigned task calendar follow the project calendar. Tasks with an assigned task calendar use the working hours, holidays, and exceptions defined in that calendar for scheduling and duration calculations.
  • Duration calculations: Changing hoursPerDay recalculates day-based duration values without changing the scheduled start and end dates.

See also

Calendar Settings in Angular Gantt Chart Component

The Gantt Chart component supports advanced calendar configuration through the calendarSettings property, enabling management of working hours, holidays, and task-specific scheduling. Calendar settings control how the Gantt Chart calculates task duration, determines working days, and schedules dependencies.

The calendarSettings property contains two key configurations:

  • Project Calendar: Defines working hours and holidays for the entire project, applied to all tasks by default
  • Task Calendars: Defines custom working days and holidays for specific tasks, enabling team-specific or shift-based scheduling

Project calendar

The calendarSettings.projectCalendar defines the default working hours and non-working days for the entire project. All tasks follow the project calendar unless assigned a task-specific calendar.

Configure project working hours and exceptions

Working hours are defined per day using start and end times. The following example configures the project to have working hours from 9:00 AM to 5:00 PM with a lunch break from 12:00 PM to 1:00 PM. Calendar exceptions allow overriding working hours for specific dates, enabling custom scheduling for special working days or non-working days that don’t fit the standard holiday definition:

import { Component } from '@angular/core';
import {
  GanttAllModule,
  TaskFieldsModel,
  LabelSettingsModel,
  CalendarSettingsModel,
  DayMarkersService
} from '@syncfusion/ej2-angular-gantt';
import { GanttData } from './data';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttAllModule],
  template: `
    <ejs-gantt
      [dataSource]="data"
      height="450px"
      [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate"
      [taskFields]="taskFields"
      [labelSettings]="labelSettings"
      [calendarSettings]="calendarSettings">

      <e-columns>
        <e-column field="TaskId" headerText="ID" width="80"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="250"></e-column>
        <e-column field="StartDate" headerText="Start Date"></e-column>
        <e-column field="Duration" headerText="Duration"></e-column>
      </e-columns>

    </ejs-gantt>
  `,
  providers: [DayMarkersService]
})
export class AppComponent {
  public data: object[] = GanttData;

  public projectStartDate: Date = new Date('04/01/2026');
  public projectEndDate: Date = new Date('04/30/2026');

  public taskFields: TaskFieldsModel = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    parentID: 'ParentId'
  };

  public labelSettings: LabelSettingsModel = {
    leftLabel: 'TaskName'
  };

  public calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 12 },
        { from: 13, to: 17 }
      ],
      exceptions: [
        {
          from: new Date('04/06/2026'),
          to: new Date('04/06/2026'),
          name: 'Extended Working Day',
          isWorking: true,
          workingTime: [
            { from: 8, to: 18 }
          ]
        }
      ]
    }
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Define project holidays

Holidays are non-working dates that exclude time from task calculations. The following example defines holidays for April 10 and April 17, excluding these dates from task scheduling calculations:

import { Component } from '@angular/core';
import {
  GanttAllModule,
  TaskFieldsModel,
  LabelSettingsModel,
  CalendarSettingsModel,
  DayMarkersService
} from '@syncfusion/ej2-angular-gantt';
import { GanttData } from './data';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttAllModule],
  template: `
    <ejs-gantt
      [dataSource]="data"
      height="450px"
      [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate"
      [taskFields]="taskFields"
      [labelSettings]="labelSettings"
      [calendarSettings]="calendarSettings">

      <e-columns>
        <e-column field="TaskId" headerText="ID" width="80"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="250"></e-column>
        <e-column field="StartDate" headerText="Start Date"></e-column>
        <e-column field="Duration" headerText="Duration"></e-column>
      </e-columns>

    </ejs-gantt>
  `,
  providers: [DayMarkersService]
})
export class AppComponent {
  public data: object[] = GanttData;

  public projectStartDate: Date = new Date('04/01/2026');
  public projectEndDate: Date = new Date('04/30/2026');

  public taskFields: TaskFieldsModel = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    parentID: 'ParentId'
  };

  public labelSettings: LabelSettingsModel = {
    leftLabel: 'TaskName'
  };

  public calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 12 },
        { from: 13, to: 17 }
      ],
      exceptions: [
        {
          from: new Date('04/06/2026'),
          to: new Date('04/06/2026'),
          name: 'Extended Working Day',
          isWorking: true,
          workingTime: [
            { from: 8, to: 18 }
          ]
        }
      ]
    }
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Task calendars

Task calendars enable specific tasks to use custom working days and holidays instead of the project calendar. This is useful for managing work across different shifts, regions, or external teams with different availability.

Assign task-specific calendars with exceptions

To assign a custom calendar to a task, first define the calendar in calendarSettings.taskCalendar, then reference it using the calendarId property in the task data. Calendar exceptions allow defining specific dates with custom working days, enabling team-specific scheduling adjustments such as split shifts or holidays that differ from the main schedule.

When a task is assigned a calendar through calendarId, that task follows only the assigned task calendar. The assigned task calendar overrides the project calendar for that task. Working days, holidays, and calendar exceptions defined in the assigned calendar are used when calculating the task schedule and working duration. Other task calendars are not considered when scheduling that task.

The following example defines two task calendars with different working days, task-specific exceptions, and assigns them to specific tasks:

import { Component } from '@angular/core';
import {
  GanttModule,
  TaskFieldsModel,
  LabelSettingsModel,
  CalendarSettingsModel
} from '@syncfusion/ej2-angular-gantt';
import { GanttData } from './datasource';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule],
  template: `
    <ejs-gantt
      [dataSource]="data"
      height="450px"
      [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate"
      [taskFields]="taskFields"
      [labelSettings]="labelSettings"
      [calendarSettings]="calendarSettings">

      <e-columns>
        <e-column field="TaskId" headerText="ID" width="80"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="250"></e-column>
        <e-column field="StartDate" headerText="Start Date"></e-column>
        <e-column field="Duration" headerText="Duration"></e-column>
      </e-columns>

    </ejs-gantt>
  `
})
export class AppComponent {
  public data: object[] = GanttData;

  public projectStartDate: Date = new Date('04/01/2026');
  public projectEndDate: Date = new Date('04/30/2026');

  public taskFields: TaskFieldsModel = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    parentID: 'ParentId',
    calendarId: 'CalendarId'
  };

  public labelSettings: LabelSettingsModel = {
    leftLabel: 'TaskName'
  };

  public calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 17 }
      ]
    },
    taskCalendars: [
      {
        calendarId: 'day-shift',
        workingTime: [
          { from: 9, to: 17 }
        ],
        holidays: [],
        exceptions: [
          {
            from: new Date('04/09/2026'),
            to: new Date('04/09/2026'),
            name: 'Team Meeting Day',
            isWorking: true,
            workingTime: [
              { from: 10, to: 16 }
            ]
          }
        ]
      },
      {
        calendarId: 'night-shift',
        workingTime: [
          { from: 17, to: 9 }
        ],
        holidays: [],
        exceptions: [
          {
            from: new Date('04/10/2026'),
            to: new Date('04/10/2026'),
            name: 'Maintenance Window',
            isWorking: true,
            workingTime: [
              { from: 18, to: 8 }
            ]
          }
        ]
      }
    ]
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Define task calendar holidays

Task calendars can include holidays that override project calendar holidays for the assigned task. These holidays are considered when calculating the task schedule and working duration. The following example configures a task calendar with specific holidays:

import { Component } from '@angular/core';
import {
  GanttModule,
  TaskFieldsModel,
  LabelSettingsModel,
  CalendarSettingsModel,
  DayMarkersService
} from '@syncfusion/ej2-angular-gantt';
import { GanttData } from './data';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule],
  providers: [DayMarkersService],
  template: `
    <ejs-gantt
      [dataSource]="data"
      height="450px"
      [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate"
      [taskFields]="taskFields"
      [labelSettings]="labelSettings"
      [calendarSettings]="calendarSettings">

      <e-columns>
        <e-column field="TaskId" headerText="ID" width="80"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="250"></e-column>
        <e-column field="StartDate" headerText="Start Date"></e-column>
        <e-column field="Duration" headerText="Duration"></e-column>
      </e-columns>

    </ejs-gantt>
  `
})
export class AppComponent {
  public data: object[] = GanttData;

  public projectStartDate: Date = new Date('04/01/2026');
  public projectEndDate: Date = new Date('04/30/2026');

  public taskFields: TaskFieldsModel = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    parentID: 'ParentId',
    calendarId: 'CalendarId'
  };

  public labelSettings: LabelSettingsModel = {
    leftLabel: 'TaskName'
  };

  public calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [{ from: 9, to: 17 }],
      holidays: [
        {
          from: new Date('04/10/2026'),
          to: new Date('04/10/2026'),
          label: 'Regional Holiday'
        }
      ]
    },
    taskCalendars: [
      {
        calendarId: 'local-team',
        holidays: [
          {
            from: new Date('04/05/2026'),
            to: new Date('04/05/2026'),
            label: 'Local Holiday'
          }
        ]
      },
      {
        calendarId: 'offshore-team',
        holidays: [
          {
            from: new Date('04/08/2026'),
            to: new Date('04/08/2026'),
            label: 'Offshore Holiday'
          }
        ]
      }
    ]
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Configure hours per day for task durations

The hoursPerDay property defines the number of hours used to represent one day when calculating task durations. Changing hoursPerDay recalculates day-based duration values using the existing working duration of the task. This affects how duration is displayed and calculated in days, but does not modify the task’s start date, end date, or underlying working duration.

For example, a task with 32 hours of working duration is displayed as 4 days when hoursPerDay is set to 8. If hoursPerDay is changed to 16, the same task is displayed as 2 days. The task schedule remains unchanged because the underlying working duration is not modified.

The following example demonstrates how changing hoursPerDay affects duration calculations.

import { Component, ViewChild } from '@angular/core';
import {
  GanttModule,
  GanttComponent,
  TaskFieldsModel,
  LabelSettingsModel,
  CalendarSettingsModel
} from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { GanttData } from './data';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule, ButtonModule],
  template: `
    <button ejs-button id="updateHoursPerDay" (click)="updateHoursPerDay()">
      Update Hours Per Day
    </button>

    <ejs-gantt
      #gantt
      [dataSource]="data"
      height="450px"
      [hoursPerDay]="hoursPerDay"
      [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate"
      [taskFields]="taskFields"
      [labelSettings]="labelSettings"
      [calendarSettings]="calendarSettings">

      <e-columns>
        <e-column field="TaskId" headerText="ID" width="80"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="250"></e-column>
        <e-column field="StartDate" headerText="Start Date"></e-column>
        <e-column field="Duration" headerText="Duration"></e-column>
      </e-columns>

    </ejs-gantt>
  `
})
export class AppComponent {
  @ViewChild('gantt')
  public ganttInstance!: GanttComponent;

  public data: object[] = GanttData;

  public hoursPerDay: number = 8;

  public projectStartDate: Date = new Date('04/01/2026');
  public projectEndDate: Date = new Date('04/30/2026');

  public taskFields: TaskFieldsModel = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    parentID: 'ParentId'
  };

  public labelSettings: LabelSettingsModel = {
    leftLabel: 'TaskName'
  };

  public calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 12 },
        { from: 13, to: 17 }
      ],
      exceptions: [
        {
          from: new Date('04/06/2026'),
          to: new Date('04/06/2026'),
          label: 'Extended Working Day'
        }
      ]
    }
  };

  public updateHoursPerDay(): void {
    this.ganttInstance.hoursPerDay = 16;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Note: The default hoursPerDay value is 8 hours. When a task has 4 days duration with the hoursPerDay value of 6, the total working hours = 4 days × 6 hours = 24 hours. If the calendar’s working time is configured as 24 hours (0:00 to 24:00), these 24 hours fit within a single calendar day, so the task displays as 1 calendar day on the chart, even though the duration specification is 4 days.

Impact on task scheduling

Calendar settings directly affect how task duration is calculated and when tasks are scheduled:

  • Working hours: Task durations ignore non-working hours. A 2-day task completed during 9 AM-5 PM working hours uses the same elapsed time as a 2-day task across multiple days with shorter working hours
  • Holidays: Tasks skip over holiday dates, extending the end date accordingly to maintain the required working duration
  • Weekends: By default, weekends are treated as non-working days when includeWeekend is set to false
  • Task dependencies: Dependency calculations use the predecessor task’s calendar to determine when the successor task can start
  • Task calendars: Tasks without an assigned task calendar follow the project calendar. Tasks with an assigned task calendar use the working hours, holidays, and exceptions defined in that calendar for scheduling and duration calculations.
  • Duration calculations: Changing hoursPerDay recalculates day-based duration values without changing the scheduled start and end dates.

See also

Calendar Settings in React Gantt Chart Component

The Gantt Chart component supports advanced calendar configuration through the calendarSettings property, enabling management of working hours, holidays, and task-specific scheduling. Calendar settings control how the Gantt Chart calculates task duration, determines working days, and schedules dependencies.

The calendarSettings property contains two key configurations:

  • Project Calendar: Defines working hours and holidays for the entire project, applied to all tasks by default
  • Task Calendars: Defines custom working days and holidays for specific tasks, enabling team-specific or shift-based scheduling

Project calendar

The calendarSettings.projectCalendar defines the default working hours and non-working days for the entire project. All tasks follow the project calendar unless assigned a task-specific calendar.

Configure project working hours and exceptions

Working hours are defined per day using start and end times. The following example configures the project to have working hours from 9:00 AM to 5:00 PM with a lunch break from 12:00 PM to 1:00 PM. Calendar exceptions allow overriding working hours for specific dates, enabling custom scheduling for special working days or non-working days that don’t fit the standard holiday definition:

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    Inject
} from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    };

    const labelSettings = {
        leftLabel: 'TaskName'
    };

    const calendarSettings = {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 12 },
                { from: 13, to: 17 }
            ],
            exceptions: [
                {
                    from: new Date('04/06/2026'),
                    to: new Date('04/06/2026'),
                    label: 'Extended Working Day'
                }
            ]
        }
    };

    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date('04/01/2026')}
            projectEndDate={new Date('04/30/2026')}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    LabelSettingsModel,
    TaskFieldsModel,
    CalendarSettingsModel
} from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields: TaskFieldsModel = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    };

    const labelSettings: LabelSettingsModel = {
        leftLabel: 'TaskName'
    };

    const calendarSettings: CalendarSettingsModel = {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 12 },
                { from: 13, to: 17 }
            ],
            exceptions: [
                {
                    from: new Date('04/06/2026'),
                    to: new Date('04/06/2026'),
                    label: 'Extended Working Day'
                }
            ]
        }
    };

    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date('04/01/2026')}
            projectEndDate={new Date('04/30/2026')}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Define project holidays

Holidays are non-working dates that exclude time from task calculations. The following example defines holidays for April 10 and April 17, excluding these dates from task scheduling calculations:

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject } from '@syncfusion/ej2-react-gantt';
import { DayMarkers } from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    };

    const labelSettings = {
        leftLabel: 'TaskName'
    };

    const calendarSettings = {
        projectCalendar: {
            holidays: [
                {
                    from: new Date('04/10/2026'),
                    to: new Date('04/10/2026'),
                    label: 'Holiday 1'
                },
                {
                    from: new Date('04/17/2026'),
                    to: new Date('04/17/2026'),
                    label: 'Holiday 2'
                }
            ]
        }
    };

    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date('04/01/2026')}
            projectEndDate={new Date('04/30/2026')}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[DayMarkers]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, LabelSettingsModel, TaskFieldsModel, Inject } from '@syncfusion/ej2-react-gantt';
import { DayMarkers } from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields: TaskFieldsModel = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId'
    };

    const labelSettings: LabelSettingsModel = {
        leftLabel: 'TaskName'
    };

    const calendarSettings = {
        projectCalendar: {
            holidays: [
                {
                    from: new Date('04/10/2026'),
                    to: new Date('04/10/2026'),
                    label: 'Holiday 1'
                },
                {
                    from: new Date('04/17/2026'),
                    to: new Date('04/17/2026'),
                    label: 'Holiday 2'
                }
            ]
        }
    };

    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date('04/01/2026')}
            projectEndDate={new Date('04/30/2026')}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[DayMarkers]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Task calendars

Task calendars enable specific tasks to use custom working days and holidays instead of the project calendar. This is useful for managing work across different shifts, regions, or external teams with different availability.

Assign task-specific calendars with exceptions

To assign a custom calendar to a task, first define the calendar in calendarSettings.taskCalendar, then reference it using the calendarId property in the task data. Calendar exceptions allow defining specific dates with custom working days, enabling team-specific scheduling adjustments such as split shifts or holidays that differ from the main schedule.

When a task is assigned a calendar through calendarId, that task follows only the assigned task calendar. The assigned task calendar overrides the project calendar for that task. Working days, holidays, and calendar exceptions defined in the assigned calendar are used when calculating the task schedule and working duration. Other task calendars are not considered when scheduling that task.

The following example defines two task calendars with different working days, task-specific exceptions, and assigns them to specific tasks:

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    Inject
} from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId',
        calendarId: 'CalendarId'
    };

    const labelSettings = {
        leftLabel: 'TaskName'
    };

    const calendarSettings = {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 17 }
            ]
        },
        taskCalendars: [
            {
                calendarId: 'day-shift',
                workingTime: [{ from: 9, to: 17 }],
                holidays: [],
                exceptions: [
                    {
                        from: new Date('04/09/2026'),
                        to: new Date('04/09/2026'),
                        name: 'Team Meeting Day',
                        isWorking: true,
                        workingTime: [{ from: 10, to: 16 }]
                    }
                ]
            },
            {
                calendarId: 'night-shift',
                workingTime: [{ from: 17, to: 9 }],
                holidays: [],
                exceptions: [
                    {
                        from: new Date('04/10/2026'),
                        to: new Date('04/10/2026'),
                        name: 'Maintenance Window',
                        isWorking: true,
                        workingTime: [{ from: 18, to: 8 }]
                    }
                ]
            }
        ]
    };

    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date('04/01/2026')}
            projectEndDate={new Date('04/30/2026')}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    Inject,
    LabelSettingsModel,
    TaskFieldsModel,
    CalendarSettingsModel
} from '@syncfusion/ej2-react-gantt';
import { GanttData } from './datasource';

function App() {
    const taskFields: TaskFieldsModel = {
        id: 'TaskId',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        parentID: 'ParentId',
        calendarId: 'CalendarId'
    };
    const labelSettings: LabelSettingsModel = {
        leftLabel: 'TaskName'
    };
    const calendarSettings: CalendarSettingsModel = {
        projectCalendar: {
            workingTime: [
                { from: 9, to: 17 }
            ]
        },
        taskCalendars: [
            {
                calendarId: 'day-shift',
                workingTime: [{ from: 9, to: 17 }],
                holidays: [],
                exceptions: [{ from: new Date('04/09/2026'), to: new Date('04/09/2026'), name: 'Team Meeting Day', isWorking: true, workingTime: [{ from: 10, to: 16 }] }]
            },
            {
                calendarId: 'night-shift',
                workingTime: [{ from: 17, to: 9 }],
                holidays: [],
                exceptions: [{ from: new Date('04/10/2026'), to: new Date('04/10/2026'), name: 'Maintenance Window', isWorking: true, workingTime: [{ from: 18, to: 8 }] }]
            }
        ]
    };

    return <GanttComponent dataSource={GanttData} height="450px" projectStartDate={new Date('04/01/2026')} projectEndDate={new Date('04/30/2026')} taskFields={taskFields} labelSettings={labelSettings} calendarSettings={calendarSettings}>
        <ColumnsDirective>
            <ColumnDirective field="TaskId" headerText="ID" width="80" />
            <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
            <ColumnDirective field="StartDate" headerText="Start Date" />
            <ColumnDirective field="Duration" headerText="Duration" />
        </ColumnsDirective>
        <Inject services={[]} />
    </GanttComponent>;
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Define task calendar holidays

Task calendars can include holidays that override project calendar holidays for the assigned task. These holidays are considered when calculating the task schedule and working duration. The following example configures a task calendar with specific holidays:

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    Inject,
    DayMarkers,
} from "@syncfusion/ej2-react-gantt";
import { GanttData } from "./datasource";

function App() {
    const taskFields = {
        id: "TaskId",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        parentID: "ParentId",
        calendarId: "CalendarId",
    };
    const labelSettings = {
        leftLabel: "TaskName",
    };
    const calendarSettings = {
        projectCalendar: {
            workingTime: [{ from: 9, to: 17 }],
            holidays: [
                {
                    from: new Date("04/10/2026"),
                    to: new Date("04/10/2026"),
                    label: "Regional Holiday",
                },
            ],
        },
        taskCalendars: [
            {
                calendarId: "local-team",
                holidays: [
                    {
                        from: new Date("04/05/2026"),
                        to: new Date("04/05/2026"),
                        label: "Local Holiday",
                    },
                ],
            },
            {
                calendarId: "offshore-team",
                holidays: [
                    {
                        from: new Date("04/08/2026"),
                        to: new Date("04/08/2026"),
                        label: "Offshore Holiday",
                    },
                ],
            },
        ],
    };
    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date("04/01/2026")}
            projectEndDate={new Date("04/30/2026")}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[DayMarkers]} />
        </GanttComponent>
    );
}
ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    GanttComponent,
    ColumnsDirective,
    ColumnDirective,
    Inject,
    LabelSettingsModel,
    TaskFieldsModel,
    CalendarSettingsModel,
    DayMarkers,
} from "@syncfusion/ej2-react-gantt";
import { GanttData } from "./datasource";

function App() {
    const taskFields: TaskFieldsModel = {
        id: "TaskId",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        parentID: "ParentId",
        calendarId: "CalendarId",
    };
    const labelSettings: LabelSettingsModel = {
        leftLabel: "TaskName",
    };
    const calendarSettings: CalendarSettingsModel = {
        projectCalendar: {
            workingTime: [{ from: 9, to: 17 }],
            holidays: [
                {
                    from: new Date("04/10/2026"),
                    to: new Date("04/10/2026"),
                    label: "Regional Holiday",
                },
            ],
        },
        taskCalendars: [
            {
                calendarId: "local-team",
                holidays: [
                    {
                        from: new Date("04/05/2026"),
                        to: new Date("04/05/2026"),
                        label: "Local Holiday",
                    },
                ],
            },
            {
                calendarId: "offshore-team",
                holidays: [
                    {
                        from: new Date("04/08/2026"),
                        to: new Date("04/08/2026"),
                        label: "Offshore Holiday",
                    },
                ],
            },
        ],
    };
    return (
        <GanttComponent
            dataSource={GanttData}
            height="450px"
            projectStartDate={new Date("04/01/2026")}
            projectEndDate={new Date("04/30/2026")}
            taskFields={taskFields}
            labelSettings={labelSettings}
            calendarSettings={calendarSettings}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskId" headerText="ID" width="80" />
                <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                <ColumnDirective field="StartDate" headerText="Start Date" />
                <ColumnDirective field="Duration" headerText="Duration" />
            </ColumnsDirective>
            <Inject services={[DayMarkers]} />
        </GanttComponent>
    );
}
ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Configure hours per day for task durations

The hoursPerDay property defines the number of hours used to represent one day when calculating task durations. Changing hoursPerDay recalculates day-based duration values using the existing working duration of the task. This affects how duration is displayed and calculated in days, but does not modify the task’s start date, end date, or underlying working duration.

For example, a task with 32 hours of working duration is displayed as 4 days when hoursPerDay is set to 8. If hoursPerDay is changed to 16, the same task is displayed as 2 days. The task schedule remains unchanged because the underlying working duration is not modified.

The following example demonstrates how changing hoursPerDay affects duration calculations.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  ColumnsDirective,
  ColumnDirective,
} from "@syncfusion/ej2-react-gantt";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import { GanttData } from "./datasource";

function App() {
  let ganttInstance;

  const taskFields = {
    id: "TaskId",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    parentID: "ParentId",
  };

  const labelSettings = {
    leftLabel: "TaskName",
  };

  const calendarSettings = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 12 },
        { from: 13, to: 17 },
      ],
      exceptions: [
        {
          from: new Date("04/06/2026"),
          to: new Date("04/06/2026"),
          label: "Extended Working Day"
        },
      ],
    },
  };

  const updateHoursPerDay = () => {
    if (ganttInstance) {
      ganttInstance.hoursPerDay = 16;
    }
  };

  return (
    <div>
      <ButtonComponent id="updateHoursPerDay" onClick={updateHoursPerDay}>
        Update Hours Per Day
      </ButtonComponent>

      <GanttComponent
        ref={(gantt) => {
          ganttInstance = gantt;
        }}
        dataSource={GanttData}
        height="450px"
        hoursPerDay={8}
        projectStartDate={new Date("04/01/2026")}
        projectEndDate={new Date("04/30/2026")}
        taskFields={taskFields}
        labelSettings={labelSettings}
        calendarSettings={calendarSettings}
      >
        <ColumnsDirective>
          <ColumnDirective field="TaskId" headerText="ID" width="80" />
          <ColumnDirective
            field="TaskName"
            headerText="Task Name"
            width="250"
          />
          <ColumnDirective field="StartDate" headerText="Start Date" />
          <ColumnDirective field="Duration" headerText="Duration" />
        </ColumnsDirective>
      </GanttComponent>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  ColumnsDirective,
  ColumnDirective,
  LabelSettingsModel,
  TaskFieldsModel,
  CalendarSettingsModel,
} from "@syncfusion/ej2-react-gantt";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import { GanttData } from "./datasource";

function App() {
  let ganttInstance: GanttComponent | null;

  const taskFields: TaskFieldsModel = {
    id: "TaskId",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    parentID: "ParentId",
  };

  const labelSettings: LabelSettingsModel = {
    leftLabel: "TaskName",
  };

  const calendarSettings: CalendarSettingsModel = {
    projectCalendar: {
      workingTime: [
        { from: 9, to: 12 },
        { from: 13, to: 17 },
      ],
      exceptions: [
        {
          from: new Date("04/06/2026"),
          to: new Date("04/06/2026"),
          label: "Extended Working Day"
        },
      ],
    },
  };

  const updateHoursPerDay = (): void => {
    if (ganttInstance) {
      ganttInstance.hoursPerDay = 16;
    }
  };

  return (
    <div>
      <ButtonComponent id="updateHoursPerDay" onClick={updateHoursPerDay}>
        Update Hours Per Day
      </ButtonComponent>

      <GanttComponent
        ref={(gantt) => {
          ganttInstance = gantt;
        }}
        dataSource={GanttData}
        height="450px"
        hoursPerDay={8}
        projectStartDate={new Date("04/01/2026")}
        projectEndDate={new Date("04/30/2026")}
        taskFields={taskFields}
        labelSettings={labelSettings}
        calendarSettings={calendarSettings}
      >
        <ColumnsDirective>
          <ColumnDirective field="TaskId" headerText="ID" width="80" />
          <ColumnDirective
            field="TaskName"
            headerText="Task Name"
            width="250"
          />
          <ColumnDirective field="StartDate" headerText="Start Date" />
          <ColumnDirective field="Duration" headerText="Duration" />
        </ColumnsDirective>
      </GanttComponent>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Note: The default hoursPerDay value is 8 hours. When a task has 4 days duration with the hoursPerDay value of 6, the total working hours = 4 days × 6 hours = 24 hours. If the calendar’s working time is configured as 24 hours (0:00 to 24:00), these 24 hours fit within a single calendar day, so the task displays as 1 calendar day on the chart, even though the duration specification is 4 days.

Impact on task scheduling

Calendar settings directly affect how task duration is calculated and when tasks are scheduled:

  • Working hours: Task durations ignore non-working hours. A 2-day task completed during 9 AM-5 PM working hours uses the same elapsed time as a 2-day task across multiple days with shorter working hours
  • Holidays: Tasks skip over holiday dates, extending the end date accordingly to maintain the required working duration
  • Weekends: By default, weekends are treated as non-working days when includeWeekend is set to false
  • Task dependencies: Dependency calculations use the predecessor task’s calendar to determine when the successor task can start
  • Task calendars: Tasks without an assigned task calendar follow the project calendar. Tasks with an assigned task calendar use the working hours, holidays, and exceptions defined in that calendar for scheduling and duration calculations.
  • Duration calculations: Changing hoursPerDay recalculates day-based duration values without changing the scheduled start and end dates.

See also

Calendar Settings in Vue Gantt Chart Component

The Gantt Chart component supports advanced calendar configuration through the calendarSettings property, enabling management of working hours, holidays, and task-specific scheduling. Calendar settings control how the Gantt Chart calculates task duration, determines working days, and schedules dependencies.

The calendarSettings property contains two key configurations:

  • Project Calendar: Defines working hours and holidays for the entire project, applied to all tasks by default
  • Task Calendars: Defines custom working days and holidays for specific tasks, enabling team-specific or shift-based scheduling

Project calendar

The calendarSettings.projectCalendar defines the default working hours and non-working days for the entire project. All tasks follow the project calendar unless assigned a task-specific calendar.

Configure project working hours and exceptions

Working hours are defined per day using start and end times. The following example configures the project to have working hours from 9:00 AM to 5:00 PM with a lunch break from 12:00 PM to 1:00 PM. Calendar exceptions allow overriding working hours for specific dates, enabling custom scheduling for special working days or non-working days that don’t fit the standard holiday definition:

<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script setup>
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';

const data = GanttData;
const height = '450px';
const projectStartDate = new Date('04/01/2026');
const projectEndDate = new Date('04/30/2026');
const taskFields = {
	id: 'TaskId',
	name: 'TaskName',
	startDate: 'StartDate',
	duration: 'Duration',
	parentID: 'ParentId'
};
const labelSettings = { leftLabel: 'TaskName' };
const calendarSettings = {
	projectCalendar: {
		workingTime: [
			{ from: 9, to: 12 },
			{ from: 13, to: 17 }
		],
		exceptions: [{
			from: new Date('04/06/2026'),
			to: new Date('04/06/2026'),
			name: 'Extended Working Day',
			isWorking: true,
			workingTime: [{ from: 8, to: 18 }]
		}]
	}
};
const columns = [
	{ field: 'TaskId', headerText: 'ID', width: '80' },
	{ field: 'TaskName', headerText: 'Task Name', width: '250' },
	{ field: 'StartDate', headerText: 'Start Date' },
	{ field: 'Duration', headerText: 'Duration' }
];
</script>
<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';
export default {
	name: "App",
	components: {
		"ejs-gantt": GanttComponent
	},
	data: function() {
		return {
			data: GanttData,
			height: '450px',
			projectStartDate: new Date('04/01/2026'),
			projectEndDate: new Date('04/30/2026'),
			taskFields: {
				id: 'TaskId',
				name: 'TaskName',
				startDate: 'StartDate',
				duration: 'Duration',
				parentID: 'ParentId'
			},
			labelSettings: {
				leftLabel: 'TaskName'
			},
			calendarSettings: {
				projectCalendar: {
					workingTime: [
						{ from: 9, to: 12 },
						{ from: 13, to: 17 }
					],
					exceptions: [{
						from: new Date('04/06/2026'),
						to: new Date('04/06/2026'),
						name: 'Extended Working Day',
						isWorking: true,
						workingTime: [{ from: 8, to: 18 }]
					}]
				}
			},
			columns: [
				{ field: 'TaskId', headerText: 'ID', width: '80' },
				{ field: 'TaskName', headerText: 'Task Name', width: '250' },
				{ field: 'StartDate', headerText: 'Start Date' },
				{ field: 'Duration', headerText: 'Duration' }
			]
		};
	}
};
</script>

Define project holidays

Holidays are non-working dates that exclude time from task calculations. The following example defines holidays for April 10 and April 17, excluding these dates from task scheduling calculations:

<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script setup>
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';

const data = GanttData;
const height = '450px';
const projectStartDate = new Date('04/01/2026');
const projectEndDate = new Date('04/30/2026');
const taskFields = {
	id: 'TaskId',
	name: 'TaskName',
	startDate: 'StartDate',
	duration: 'Duration',
	parentID: 'ParentId'
};
const labelSettings = { leftLabel: 'TaskName' };
const calendarSettings = {
	projectCalendar: {
		workingTime: [{ from: 9, to: 17 }],
		holidays: [
			{ from: new Date('04/10/2026'), to: new Date('04/10/2026'), label: 'Holiday 1' },
			{ from: new Date('04/17/2026'), to: new Date('04/17/2026'), label: 'Holiday 2' }
		]
	}
};
const columns = [
	{ field: 'TaskId', headerText: 'ID', width: '80' },
	{ field: 'TaskName', headerText: 'Task Name', width: '250' },
	{ field: 'StartDate', headerText: 'Start Date' },
	{ field: 'Duration', headerText: 'Duration' }
];
</script>
<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';
export default {
	name: "App",
	components: {
		"ejs-gantt": GanttComponent
	},
	data: function() {
		return {
			data: GanttData,
			height: '450px',
			projectStartDate: new Date('04/01/2026'),
			projectEndDate: new Date('04/30/2026'),
			taskFields: {
				id: 'TaskId',
				name: 'TaskName',
				startDate: 'StartDate',
				duration: 'Duration',
				parentID: 'ParentId'
			},
			labelSettings: {
				leftLabel: 'TaskName'
			},
			calendarSettings: {
				projectCalendar: {
					workingTime: [{ from: 9, to: 17 }],
					holidays: [
						{ from: new Date('04/10/2026'), to: new Date('04/10/2026'), label: 'Holiday 1' },
						{ from: new Date('04/17/2026'), to: new Date('04/17/2026'), label: 'Holiday 2' }
					]
				}
			},
			columns: [
				{ field: 'TaskId', headerText: 'ID', width: '80' },
				{ field: 'TaskName', headerText: 'Task Name', width: '250' },
				{ field: 'StartDate', headerText: 'Start Date' },
				{ field: 'Duration', headerText: 'Duration' }
			]
		};
	}
};
</script>

Task calendars

Task calendars enable specific tasks to use custom working days and holidays instead of the project calendar. This is useful for managing work across different shifts, regions, or external teams with different availability.

Assign task-specific calendars with exceptions

To assign a custom calendar to a task, first define the calendar in calendarSettings.taskCalendar, then reference it using the calendarId property in the task data. Calendar exceptions allow defining specific dates with custom working days, enabling team-specific scheduling adjustments such as split shifts or holidays that differ from the main schedule.

When a task is assigned a calendar through calendarId, that task follows only the assigned task calendar. The assigned task calendar overrides the project calendar for that task. Working days, holidays, and calendar exceptions defined in the assigned calendar are used when calculating the task schedule and working duration. Other task calendars are not considered when scheduling that task.

The following example defines two task calendars with different working days, task-specific exceptions, and assigns them to specific tasks:

<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script setup>
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';

const data = GanttData;
const height = '450px';
const projectStartDate = new Date('04/01/2026');
const projectEndDate = new Date('04/30/2026');
const taskFields = {
	id: 'TaskId',
	name: 'TaskName',
	startDate: 'StartDate',
	duration: 'Duration',
	parentID: 'ParentId',
	calendarId: 'CalendarId'
};
const labelSettings = { leftLabel: 'TaskName' };
const calendarSettings = {
	projectCalendar: {
		workingTime: [{ from: 9, to: 17 }]
	},
	taskCalendars: [
		{
			calendarId: 'day-shift',
			workingTime: [{ from: 9, to: 17 }],
			holidays: [],
			exceptions: [{
				from: new Date('04/09/2026'),
				to: new Date('04/09/2026'),
				name: 'Team Meeting Day',
				isWorking: true,
				workingTime: [{ from: 10, to: 16 }]
			}]
		},
		{
			calendarId: 'night-shift',
			workingTime: [{ from: 17, to: 9 }],
			holidays: [],
			exceptions: [{
				from: new Date('04/10/2026'),
				to: new Date('04/10/2026'),
				name: 'Maintenance Window',
				isWorking: true,
				workingTime: [{ from: 18, to: 8 }]
			}]
		}
	]
};
const columns = [
	{ field: 'TaskId', headerText: 'ID', width: '80' },
	{ field: 'TaskName', headerText: 'Task Name', width: '250' },
	{ field: 'StartDate', headerText: 'Start Date' },
	{ field: 'Duration', headerText: 'Duration' }
];
</script>
<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';
export default {
	name: "App",
	components: {
		"ejs-gantt": GanttComponent
	},
	data: function() {
		return {
			data: GanttData,
			height: '450px',
			projectStartDate: new Date('04/01/2026'),
			projectEndDate: new Date('04/30/2026'),
			taskFields: {
				id: 'TaskId',
				name: 'TaskName',
				startDate: 'StartDate',
				duration: 'Duration',
				parentID: 'ParentId',
				calendarId: 'CalendarId'
			},
			labelSettings: {
				leftLabel: 'TaskName'
			},
			calendarSettings: {
				projectCalendar: {
					workingTime: [{ from: 9, to: 17 }]
				},
				taskCalendars: [
					{
						calendarId: 'day-shift',
						workingTime: [{ from: 9, to: 17 }],
						holidays: [],
						exceptions: [{
							from: new Date('04/09/2026'),
							to: new Date('04/09/2026'),
							label: 'Team Meeting Day'
						}]
					},
					{
						calendarId: 'night-shift',
						workingTime: [{ from: 17, to: 9 }],
						holidays: [],
						exceptions: [{
							from: new Date('04/10/2026'),
							to: new Date('04/10/2026'),
							label: 'Maintenance Window'
						}]
					}
				]
			},
			columns: [
				{ field: 'TaskId', headerText: 'ID', width: '80' },
				{ field: 'TaskName', headerText: 'Task Name', width: '250' },
				{ field: 'StartDate', headerText: 'Start Date' },
				{ field: 'Duration', headerText: 'Duration' }
			]
		};
	}
};
</script>

Define task calendar holidays

Task calendars can include holidays that override project calendar holidays for the assigned task. These holidays are considered when calculating the task schedule and working duration. The following example configures a task calendar with specific holidays:

<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script setup>
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';

const data = GanttData;
const height = '450px';
const projectStartDate = new Date('04/01/2026');
const projectEndDate = new Date('04/30/2026');
const taskFields = {
	id: 'TaskId',
	name: 'TaskName',
	startDate: 'StartDate',
	duration: 'Duration',
	parentID: 'ParentId',
	calendarId: 'CalendarId'
};
const labelSettings = { leftLabel: 'TaskName' };
const calendarSettings = {
	projectCalendar: {
		workingTime: [{ from: 9, to: 17 }],
		holidays: [{
			from: new Date('04/10/2026'),
			to: new Date('04/10/2026'),
			label: 'Regional Holiday'
		}]
	},
	taskCalendars: [
		{
			calendarId: 'local-team',
			holidays: [{
				from: new Date('04/05/2026'),
				to: new Date('04/05/2026'),
				label: 'Local Holiday'
			}]
		},
		{
			calendarId: 'offshore-team',
			holidays: [{
				from: new Date('04/08/2026'),
				to: new Date('04/08/2026'),
				label: 'Offshore Holiday'
			}]
		}
	]
};
const columns = [
	{ field: 'TaskId', headerText: 'ID', width: '80' },
	{ field: 'TaskName', headerText: 'Task Name', width: '250' },
	{ field: 'StartDate', headerText: 'Start Date' },
	{ field: 'Duration', headerText: 'Duration' }
];
</script>
<template>
	<div>
		<ejs-gantt :dataSource="data" :height="height" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';
export default {
	name: "App",
	components: {
		"ejs-gantt": GanttComponent
	},
	data: function() {
		return {
			data: GanttData,
			height: '450px',
			projectStartDate: new Date('04/01/2026'),
			projectEndDate: new Date('04/30/2026'),
			taskFields: {
				id: 'TaskId',
				name: 'TaskName',
				startDate: 'StartDate',
				duration: 'Duration',
				parentID: 'ParentId',
				calendarId: 'CalendarId'
			},
			labelSettings: {
				leftLabel: 'TaskName'
			},
			calendarSettings: {
				projectCalendar: {
					workingTime: [{ from: 9, to: 17 }],
					holidays: [{
						from: new Date('04/10/2026'),
						to: new Date('04/10/2026'),
						label: 'Regional Holiday'
					}]
				},
				taskCalendars: [
					{
						calendarId: 'local-team',
						holidays: [{
							from: new Date('04/05/2026'),
							to: new Date('04/05/2026'),
							label: 'Local Holiday'
						}]
					},
					{
						calendarId: 'offshore-team',
						holidays: [{
							from: new Date('04/08/2026'),
							to: new Date('04/08/2026'),
							label: 'Offshore Holiday'
						}]
					}
				]
			},
			columns: [
				{ field: 'TaskId', headerText: 'ID', width: '80' },
				{ field: 'TaskName', headerText: 'Task Name', width: '250' },
				{ field: 'StartDate', headerText: 'Start Date' },
				{ field: 'Duration', headerText: 'Duration' }
			]
		};
	}
};
</script>

Configure hours per day for task durations

The hoursPerDay property defines the number of hours used to represent one day when calculating task durations. Changing hoursPerDay recalculates day-based duration values using the existing working duration of the task. This affects how duration is displayed and calculated in days, but does not modify the task’s start date, end date, or underlying working duration.

For example, a task with 32 hours of working duration is displayed as 4 days when hoursPerDay is set to 8. If hoursPerDay is changed to 16, the same task is displayed as 2 days. The task schedule remains unchanged because the underlying working duration is not modified.

The following example demonstrates how changing hoursPerDay affects duration calculations.

<template>
	<div>
		<button id="updateHoursPerDay" @click="updateHoursPerDay">Update Hours Per Day</button>
		<ejs-gantt ref="gantt" :dataSource="data" height="450px" :hoursPerDay="8" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
	</div>
</template>
<script setup>
import { ref } from 'vue';
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';

const gantt = ref(null);
const data = GanttData;
const projectStartDate = new Date('04/01/2026');
const projectEndDate = new Date('04/30/2026');
const taskFields = {
	id: 'TaskId',
	name: 'TaskName',
	startDate: 'StartDate',
	duration: 'Duration',
	parentID: 'ParentId'
};
const labelSettings = { leftLabel: 'TaskName' };
const calendarSettings = {
	projectCalendar: {
		workingTime: [{ from: 9, to: 12 }, { from: 13, to: 17 }],
		exceptions: [{
			from: new Date('04/06/2026'),
			to: new Date('04/06/2026'),
			name: 'Extended Working Day',
			isWorking: true,
			workingTime: [{ from: 8, to: 18 }]
		}]
	}
};
const columns = [
	{ field: 'TaskId', headerText: 'ID', width: '80' },
	{ field: 'TaskName', headerText: 'Task Name', width: '250' },
	{ field: 'StartDate', headerText: 'Start Date' },
	{ field: 'Duration', headerText: 'Duration' }
];

const updateHoursPerDay = () => {
	gantt.value.ej2Instances.hoursPerDay = 16;
};
</script>
<template>
    <div>
        <button id="updateHoursPerDay" @click="updateHoursPerDay">Update Hours Per Day</button>
        <ejs-gantt ref="gantt" :dataSource="data" height="450px" :hoursPerDay="8" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate" :taskFields="taskFields" :labelSettings="labelSettings" :calendarSettings="calendarSettings" :columns="columns"></ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { GanttData } from './data-source.js';
export default {
    name: "App", components: { "ejs-gantt": GanttComponent },
    data: function() { return {
        data: GanttData, projectStartDate: new Date('04/01/2026'), projectEndDate: new Date('04/30/2026'),
        taskFields: { id: 'TaskId', name: 'TaskName', startDate: 'StartDate', duration: 'Duration', parentID: 'ParentId' }, labelSettings: { leftLabel: 'TaskName' },
        calendarSettings: { projectCalendar: { workingTime: [{ from: 9, to: 12 }, { from: 13, to: 17 }], exceptions: [{ from: new Date('04/06/2026'), to: new Date('04/06/2026'), label: 'Extended Working Day' }] } },
        columns: [{ field: 'TaskId', headerText: 'ID', width: '80' }, { field: 'TaskName', headerText: 'Task Name', width: '250' }, { field: 'StartDate', headerText: 'Start Date' }, { field: 'Duration', headerText: 'Duration' }]
    }; },
    methods: { updateHoursPerDay: function() { this.$refs.gantt.ej2Instances.hoursPerDay = 16; } }
};
</script>

Note: The default hoursPerDay value is 8 hours. When a task has 4 days duration with the hoursPerDay value of 6, the total working hours = 4 days × 6 hours = 24 hours. If the calendar’s working time is configured as 24 hours (0:00 to 24:00), these 24 hours fit within a single calendar day, so the task displays as 1 calendar day on the chart, even though the duration specification is 4 days.

Impact on task scheduling

Calendar settings directly affect how task duration is calculated and when tasks are scheduled:

  • Working hours: Task durations ignore non-working hours. A 2-day task completed during 9 AM-5 PM working hours uses the same elapsed time as a 2-day task across multiple days with shorter working hours
  • Holidays: Tasks skip over holiday dates, extending the end date accordingly to maintain the required working duration
  • Weekends: By default, weekends are treated as non-working days when includeWeekend is set to false
  • Task dependencies: Dependency calculations use the predecessor task’s calendar to determine when the successor task can start
  • Task calendars: Tasks without an assigned task calendar follow the project calendar. Tasks with an assigned task calendar use the working hours, holidays, and exceptions defined in that calendar for scheduling and duration calculations.
  • Duration calculations: Changing hoursPerDay recalculates day-based duration values without changing the scheduled start and end dates.

See also